
///////////////////////////////////////////////////////////////////////////////////////////////
//                             Sampling frequency (defined by user)                          //
///////////////////////////////////////////////////////////////////////////////////////////////

#define FS 500.0 //Hz
#define SL 3.5 // Largo de la señal a medir (en segundos)

////////////////////////////////////////////////////////////////////////////////////////////////

#define T_delay (1000/FS) //ms
// to the pins used:
const int analogInPin = A0; // Analog input pin attached to the circuit output
const int L=SL*FS;
int t[L];
int V[L];
int i=0;
unsigned long b, a = 0;
int sensorValue1 = 0;        
int outputValue1 = 0;  

void setup() {
  // initialize serial communications at 9600 bps:
  Serial.begin(9600); 

  Serial.print("Frecuencia de muestreo: ");
  Serial.println(FS);
  Serial.print("t(ms)");
  Serial.print(" ");
  Serial.println("V_A0(mV)");
}

void loop() {
  if ((i>=0)&&(i<L))
  {
    a = millis();
    if (i==0)
      t[0] = 0 + abs(a-b);
    else
      t[i] = t[i-1] + abs(a-b);
    b = a;
    // read the analog in value (circuit output):
    sensorValue1 = analogRead(analogInPin);   
         
    // map it to the range of the analog out:
    outputValue1 = map(sensorValue1, 0, 1023, 0, 5000); 
    V[i]=outputValue1;
    i++;
    
    // wait 20 milliseconds before the next loop
    // for the analog-to-digital converter to settle
    // after the last reading:
    while ( millis()<(a + T_delay) ){
    
    }
  }
  if (i>=L)
  {
    for (int j=0;j<L;j++)
    {
      // print the results to the serial monitor:
      //Serial.print("sensor = " );                       
      Serial.print(t[j]);
      Serial.print(" ");
      Serial.println(V[j]);
    }
    i=-1;
  }
}
